$Host.UI.RawUI.WindowTitle = "AAF Driver Uninstaller v1.0"
Write-Host "Welcome to AAF Driver Uninstaller v1.0! (Created by TheDoctor for users AAF in forum TechPowerUP)"
$yes = New-Object System.Management.Automation.Host.ChoiceDescription '&Yes', 'Allows removing AAF Drivers and Software'
$no = New-Object System.Management.Automation.Host.ChoiceDescription '&No', 'Does not allow removing AAF Drivers and Software'
$options = [System.Management.Automation.Host.ChoiceDescription[]]($yes, $no)
$result = $host.ui.PromptForChoice('', 'Are you shure want to removing AAF Drivers and Software?', $options, 1)
switch ($result)
    {
    0   {
		Write-Host "Creating checkpoint for rollback..."
	    Checkpoint-Computer -Description 'Started AAF Driver Uninstaller' -RestorePointType 'MODIFY_SETTINGS'
	    Write-Host "Complete!"
	    Write-Host ""
		Write-Host "Uninstalling AAF DCH Optimus Sound..."
		Start-Process -FilePath $Env:ProgramFiles\AAF\Uninstall\unins000.exe -ArgumentList '/s'
		Remove-Item "$Env:ProgramFiles\AAF" -Recurse -Force
	    Write-Host "Complete!"
	    Write-Host ""
	    Write-Host "Removing AAF Appx Packages..."
		Get-AppxPackage A-Volute.Nahimic* -AllUsers | Remove-AppxPackage -AllUsers -WarningAction SilentlyContinue
	    Get-AppxPackage A-Volute.SonicStudio* -AllUsers | Remove-AppxPackage -AllUsers -WarningAction SilentlyContinue
		Get-AppxPackage CreativeTechnologyLtd.SoundBlasterConnect* -AllUsers | Remove-AppxPackage -AllUsers -WarningAction SilentlyContinue
	    Get-AppxPackage DolbyLaboratories.DolbyAtmos* -AllUsers | Remove-AppxPackage -AllUsers -WarningAction SilentlyContinue
		Get-AppxPackage DTSInc.DTSHeadphoneX* -AllUsers | Remove-AppxPackage -AllUsers -WarningAction SilentlyContinue
		Get-AppxPackage DTSInc.DTSSoundUnbound* -AllUsers | Remove-AppxPackage -AllUsers -WarningAction SilentlyContinue
	    Get-AppxPackage DTSInc.DTSXUltra* -AllUsers | Remove-AppxPackage -AllUsers -WarningAction SilentlyContinue
		Get-AppxPackage RealtekSemiconductorCorp.RealtekAudioControl* -AllUsers | Remove-AppxPackage -AllUsers -WarningAction SilentlyContinue
		Remove-Item "$Env:LocalAppData\AAFStyle" -Recurse -Force
		Remove-Item "$Env:ProgramData\A-Volute" -Recurse -Force
		Remove-Item "$Env:ProgramData\Creative\SoftwareLock" -Recurse -Force
		Remove-Item "$Env:ProgramData\Dolby\DAX3" -Recurse -Force
		Remove-Item "$Env:CommonProgramFiles\AAF" -Recurse -Force
		Remove-Item "$Env:ProgramFiles\WindowsApps\A-Volute.Nahimic*" -Recurse -Force
		Remove-Item "$Env:ProgramFiles\WindowsApps\A-Volute.SonicStudio*" -Recurse -Force
		Remove-Item "$Env:ProgramFiles\WindowsApps\CreativeTechnologyLtd.SoundBlasterConnect*" -Recurse -Force
		Remove-Item "$Env:ProgramFiles\WindowsApps\DolbyLaboratories.DolbyAtmos*" -Recurse -Force
		Remove-Item "$Env:ProgramFiles\WindowsApps\DTSInc.DTSHeadphoneX*" -Recurse -Force
		Remove-Item "$Env:ProgramFiles\WindowsApps\DTSInc.DTSSoundUnbound*" -Recurse -Force
		Remove-Item "$Env:ProgramFiles\WindowsApps\DTSInc.DTSXUltra*" -Recurse -Force
		Remove-Item "$Env:ProgramFiles\WindowsApps\RealtekSemiconductorCorp.RealtekAudioControl*" -Recurse -Force
	    Write-Host "Complete!"
	    Write-Host ""
	    Write-Host "Deleting AAF Services..."
	    Stop-Service -Name "UWPService" -Force
	    Stop-Service -Name "DolbyDAXAPI" -Force
	    Stop-Service -Name "DtsApo4Service" -Force
	    Stop-Service -Name "RtkAudioUniversalService" -Force
	    Stop-Service -Name "NahimicService" -Force
	    Stop-Process -Name "NahimicSvc32" -Force
	    Stop-Process -Name "NahimicSvc64" -Force
	    Remove-Item -Path "HKLM:\SYSTEM\CurrentControlSet\Services\UWPService" -Recurse -Force
	    Remove-Item -Path "HKLM:\SYSTEM\CurrentControlSet\Services\DolbyDAXAPI" -Recurse -Force
	    Remove-Item -Path "HKLM:\SYSTEM\CurrentControlSet\Services\DtsApo4Service" -Recurse -Force
	    Remove-Item -Path "HKLM:\SYSTEM\CurrentControlSet\Services\NahimicService" -Recurse -Force
	    Remove-Item -Path "HKLM:\SYSTEM\CurrentControlSet\Services\RtkAudioUniversalService" -Recurse -Force
	    Write-Host "Complete!"
	    Write-Host ""
	    Write-Host "Removing AAF Publisher EV Drivers..."
	    $oemfiles = gci $Env:SystemRoot\INF\oem*.inf
	    foreach($file in $oemfiles){if(Get-Content $file | Select-String -pattern 'AAF Publisher EV' -SimpleMatch){pnputil /delete-driver $file.name /force}}
	    Write-Host "Complete!"
	    Write-Host ""
	    Write-Host "Deleting AAF Uninstall information for prevent errors..."
	    # AAF DCH Optimus Sound
		Remove-Item -Path "HKLM:\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{F132AF7F-7BCA-4EDE-8A7C-958108FE7DBD}_is1" -Recurse -Force
	    # AAF Realtek Audio Device Tweak
		Remove-Item -Path "HKLM:\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{A8C7895E-8FA1-4290-9035-B2D170D7BD31}" -Recurse -Force
	    Write-Host "Complete!"
	    Write-Host ""
	    Write-Host "Removal completed. Please, restart your computer."
        }
    1   {
        Write-Host "Nothing changed. Exiting..."
        }
    }
Write-Output $message